$('#sources-list-toggle-all').click(function () {
  if ($(this).hasClass('-expanded')) {
    $('#sources-list [aria-expanded=true]').click();
  } else {
    $('#sources-list [aria-expanded=false]').click();
  }

  $(this).toggleClass('-expanded');
});

$('#sources-filter').keyup(function (e) {
  if (e.keyCode === 27) { // Esc
    $(this).val('');
  }

  const filterText = this.value.toUpperCase();
  const $allListElements = $('#sources-list > li');
  $allListElements.each(function () {
    const item = $(this);
    const $button = $('button', item);
    const includesFilterText = filterText && item.text().toUpperCase().includes(filterText);
    const isExpanded = $button.attr('aria-expanded') === 'true';

    if ((includesFilterText && !isExpanded) || (!includesFilterText && isExpanded)) {
      $button.click();
    }

    if (!filterText || includesFilterText) {
      item.show();
    } else {
      item.hide();
    }
  });
});
